OGRE: Ogre::HardwareIndexBuffer Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::HardwareIndexBuffer Class Referencefinal
Core » RenderSystem

Specialisation of HardwareBuffer for vertex index buffers, still abstract. More...

`#include <OgreHardwareIndexBuffer.h>`

Inheritance diagram for Ogre::HardwareIndexBuffer:
[legend]

## Public Types
enum | IndexType : uint8 { IT_16BIT , IT_32BIT }
Public Types inherited from Ogre::HardwareBuffer
enum | LockOptions : uint8 { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
typedef uint8 | Usage
enum | UsageEnum { HBU_STATIC = HBU_GPU_TO_CPU , HBU_DYNAMIC = HBU_CPU_ONLY , HBU_WRITE_ONLY = HBU_DETAIL_WRITE_ONLY , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = HBU_GPU_ONLY , HBU_DYNAMIC_WRITE_ONLY = HBU_CPU_TO_GPU , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = HBU_CPU_TO_GPU }
| Rather use HardwareBufferUsage. More...

## Public Member Functions
| HardwareIndexBuffer (HardwareBufferManagerBase *mgr, IndexType idxType, size_t numIndexes, HardwareBuffer *delegate)
| HardwareIndexBuffer (HardwareBufferManagerBase *mgr, IndexType idxType, size_t numIndexes, Usage usage, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareIndexBuffer ()
uint8 | getIndexSize (void) const
| Get the size in bytes of each index.
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
uint32 | getNumIndexes (void) const
| Get the number of indexes in this buffer.
IndexType | getType (void) const
| Get the type of indexes used in this buffer.
Public Member Functions inherited from Ogre::HardwareBuffer
| HardwareBuffer (Usage usage, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
template<typename T>
T * | _getImpl ()
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required.
void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes.
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked.
virtual bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
virtual void | readData (size_t offset, size_t length, void *pDest)
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
void | unlock (void)
| Releases the lock on this buffer.
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

## Static Public Member Functions
static size_t | indexSize (IndexType type)

## Detailed Description

Specialisation of HardwareBuffer for vertex index buffers, still abstract.

## Member Enumeration Documentation

## ◆ IndexType

enum Ogre::HardwareIndexBuffer::IndexType : uint8

Enumerator
IT_16BIT |
IT_32BIT |

## Constructor & Destructor Documentation

## ◆ HardwareIndexBuffer() [1/2]

Ogre::HardwareIndexBuffer::HardwareIndexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | IndexType | idxType,
|  | size_t | numIndexes,
|  | Usage | usage,
|  | bool | useShadowBuffer )

Should be called by HardwareBufferManager.

## ◆ HardwareIndexBuffer() [2/2]

Ogre::HardwareIndexBuffer::HardwareIndexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | IndexType | idxType,
|  | size_t | numIndexes,
|  | HardwareBuffer * | delegate )

References Ogre::HardwareBuffer::HardwareBuffer().

## ◆ ~HardwareIndexBuffer()

Ogre::HardwareIndexBuffer::~HardwareIndexBuffer | ( |  | ) |

## Member Function Documentation

## ◆ getManager()

HardwareBufferManagerBase * Ogre::HardwareIndexBuffer::getManager | ( |  | ) | const
| inline

Return the manager of this buffer, if any.

## ◆ getType()

IndexType Ogre::HardwareIndexBuffer::getType | ( | void |  | ) | const
| inline

Get the type of indexes used in this buffer.

## ◆ getNumIndexes()

uint32 Ogre::HardwareIndexBuffer::getNumIndexes | ( | void |  | ) | const
| inline

Get the number of indexes in this buffer.

## ◆ getIndexSize()

uint8 Ogre::HardwareIndexBuffer::getIndexSize | ( | void |  | ) | const
| inline

Get the size in bytes of each index.

## ◆ indexSize()

size_t Ogre::HardwareIndexBuffer::indexSize | ( | IndexType | type | ) |
| inlinestatic

References IT_16BIT.

The documentation for this class was generated from the following file:

- OgreHardwareIndexBuffer.h